/*

    Meta-Environment - An environment for language prototyping.
    Copyright (C) 2000  Stichting Mathematisch Centrum, Amsterdam, The Netherlands. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    $Id: AnnoTool.java,v 1.4 2000/04/17 15:27:27 markvdb Exp $
*/
// $Id: AnnoTool.java,v 1.4 2000/04/17 15:27:27 markvdb Exp $

package nl.cwi.gipe.stred;
import toolbus.aterm.*;
import toolbus.tool.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class AnnoTool extends Anno {

  public AnnoTool(String args[]) throws Exception {
    super(args);
  }
    
    /** Start the tool and perform initialization
     */
    public static void main(String argv[]) throws Exception {
    AnnoTool an = new AnnoTool(argv);
    an.connect();
    an.run();
  }

    /** Return the annotation on <tt>t</tt> that has label <tt>label</tt>.
	@param t The annotated ATerm
	@param label The label of the annotation
	@returns The annotation associated with the label, or null if the label does not occur in the list of annotations.
    */
    public ATerm getAnno(String label, ATerm t) throws ToolException {
	ATermPattern p;
	try {
	    p = new ATermPattern(ATerm.the_world,"snd-value(annotation(<term>))");
	}
	catch (Exception ex) {
	    throw new ToolException(this,"parse error");
	}
//System.err.println("tree: " + t + ", label:" + label);
	return p.make(t.getAnnotation(label));
    }

    /** Is called upon ToolBus termination
     */
    void recTerminate(ATerm t) {
	System.exit(0);
    }
}
