/*

    Meta-Environment - An environment for language prototyping.
    Copyright (C) 2000  Stichting Mathematisch Centrum, Amsterdam, The Netherlands. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/
// $Id: FocusStatus.java,v 1.3 2000/03/20 21:48:24 mdejonge Exp $

package nl.cwi.gipe.stred;
import toolbus.aterm.*;

public class FocusStatus {
    private static final String label = "focusstatus";
    private boolean clean = true;
    private static final String cleanstring = "clean";
    private static final String dirtystring = "dirty";

    public void setStatus(ATermAppl t){
	ATermAppl status;
	status = (ATermAppl) t.getAnnotation(label);
	if (status != null)
	    clean = status.getFun().equals("clean");
	else
	    clean = true;
    }

    public void setStatus(boolean b){
	clean = b;
    }
    
    public void setStatusAnno(ATermAppl t) {
	ATermAppl status;
	status = clean ? new ATermAppl(ATerm.the_world,cleanstring) : new ATermAppl(ATerm.the_world,dirtystring);
	t.setAnnotation(label,status);
    }

    public boolean getStatus() {
	return clean;
    }
}
