/*

    Meta-Environment - An environment for language prototyping.
    Copyright (C) 2000  Stichting Mathematisch Centrum, Amsterdam, The Netherlands. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    $Id: Subtree.java,v 1.7 2000/04/15 15:18:45 mdejonge Exp $
*/
package nl.cwi.gipe.stred;
import toolbus.aterm.*;

public class Subtree {
    public static ATerm subtree(ATerm t, Path p) throws SubtreeException {
      Path pp;
      //      System.err.println("In subtree. t = "+ t.toString() +", p = "+p.toString());
    AFun args = new AFun(ATerm.the_world,"args");
    AFun elems = new AFun(ATerm.the_world,"elems");
    AFun termterm = new AFun(ATerm.the_world,"term");
    switch (t.getType()) {
    case ATerm.APPL:
      ATermAppl at = (ATermAppl) t;
      String fun = at.getFun();
      if (p.isLeafPath()) {
	if (fun.equals("var") || fun.equals("lex") || fun.equals("appl") || fun.equals("list") || fun.equals("term")) {
	  return t;
	} 
      } else if (p.headZero()) {
	if (fun.equals("appl")) {
	  return subtree(AsFix.acc(at,args),p.tail());
	} else if (fun.equals("list")) {
	  return subtree(AsFix.acc(at,elems),p.tail());
	} else if (fun.equals("term")) {
	    pp = p.tail();
	    pp.decreaseHead();
	    return subtree(AsFix.acc(at,termterm),pp);
	}
      }
      throw new SubtreeException("SubtreeException in Subtree.subtree");
    case ATerm.ATERMS:
      ATerms ts = (ATerms) t;
      if (p.isLeafPath()) {
	if (ts.isEmpty() == false) {
	  return ts.getFirst();
	}
      } else if (p.headZero()) {
	if (ts.getFirst().getType() == ATerm.APPL) {
	  ATermAppl ta2 = (ATermAppl) ts.getFirst();
	  String fun2 = ta2.getFun();
	  if (fun2.equals("appl")) {
	    return subtree(AsFix.acc(ta2,args),p.tail());
	  } else if (fun2.equals("list")) {
	    return subtree(AsFix.acc(ta2,elems),p.tail());
	  } if (fun2.equals("term")) {
	      pp = p.tail();
	      pp.decreaseHead();
	      return subtree(AsFix.acc(ta2,termterm),pp);
	  }
	}
      } else if (p.headZero() == false) {
	  /*if (p.isLeafPath() == false) {
	    ATermAppl term = (ATermAppl) ts.getFirst();
	    if (term.getFun().equals("term")) {
		// The term itself
		return subtree(AsFix.acc(term,termterm),p.tail());
	    }
	  */
	  p.decreaseHead();
	  return subtree(ts.getNext(),p);
      } 
      throw new SubtreeException("SubtreeException in Subtree.subtree #2");
    case ATerm.LIST:
      ATermList tl = (ATermList) t;
      return subtree(tl.getATerms(), p);
    default:
	throw new SubtreeException("SubtreeException in Subtree.subtree #3");
    }
  }
}
      
      
